#!/usr/bin/python3
import requests
import logging
logging.basicConfig(format='%(asctime)s %(message)s', datefmt='%m/%d/%Y %I:%M:%S %p')


class RestClient:

    def __init__(self, config):
        self.__postEventAddress = config['server']['postEvent']
        self.__getVersion = config['server']['version']

    def post(self, payload):
        resp = None
        try:
            resp = requests.post(self.__postEventAddress, json=payload, timeout=40)
        except (requests.exceptions.ReadTimeout,
                requests.exceptions.ConnectionError) as ex:
            logging.error(ex)
        except Exception as ex:
            print("Not caught exception")
            print(ex)

        if resp is not None and resp.status_code != 201:
            raise Exception('POST {} {}'.format(self.__postEventAddress, resp.status_code))

    def getVersion(self):
        return requests.get(self.__getVersion, timeout=40).text
