from unittest.mock import MagicMock
from agent.networkTask import NetworkMonitorThread
from scapy.layers.l2 import Ether

import unittest


class TestNetworkTask(unittest.TestCase):

    def testGetDevices(self):
        gateway = "192.168.1.1"
        hwsrc = "ABCD"
        srpMock = self.createSrpMock(self.createPacket(hwsrc))

        sensorType = "monitor"
        config = {'sleep': 0.1, "name": sensorType}

        actual = NetworkMonitorThread(None, config, None).getDevicesOnNetwork(gateway, srpMock)
        expected = [{'sensorName': hwsrc, 'sensorType': sensorType, 'value': 0}]
        assert actual == expected

    def createSrpMock(self, packet):
        return MagicMock(return_value=([(None, packet)], None))

    def createPacket(self, hwsrc):
        packet = Ether()
        packet.hwsrc = hwsrc
        return packet

    def createNetifacesMock(self, gateway):
        netifacesMock = create_autospec(netifaces)
        netifacesMock.AF_INET = 0
        netifacesMock.gateways = MagicMock(return_value={'default': {0: (gateway, 'en0')}})
        return netifacesMock


if __name__ == '__main__':
    unittest.main()